/**
 * JanusHS.c
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of JanusHS.
 *
 * JanusHS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef JANUSHS_H_
#define JANUSHS_H_

#include <windows.h>
#include "util.h"
#include "gpgez.h"
#define CONFDIR "conf"
#define SECRETRING "Secring.gpg"
#define PUBLICRING "Pubring.gpg"
#define USERLIST "userlist.txt"

typedef struct global_variables {
  LPSTR pFileInput;
  LPSTR pFileOutput;
  LPSTR pKeySelected;
  LPSTR pHomeDir; /* exêtH_(\܂܂) */
  LPSTR pConfDir; /* gpg.exe conftH_(\܂܂) */
  PSTRLIST secKey;
  PSTRLIST pubKey;
  BOOL fPublic; /* Jgp\ǂ */
} JANUS_GV, *PJANUS_GV;

typedef struct janus_filelist {
  LPSTR basedir; /* t@CQ̐efBNg(\܂܂) */
  PSTRLIST files;
} JANUS_FILELIST, *PJANUS_FILELIST;

#define INPUTBOX_WITHCANCEL 1
#define INPUTBOX_SECRET 2
#define INPUTBOX_CONFIRM 4

#define WM_CREATEPROCESS   (WM_USER + 1)
#define WM_PROCESSCMDLINE  (WM_USER + 2)

enum {
  ENCTYPE_NONE,
  ENCTYPE_PUBLIC,
  ENCTYPE_SYMMETRIC
};

DWORD InputBoxEx(HWND hwnd, LPCSTR pPrompt, LPCSTR pTitle, LPSTR pBuff, UINT uMax, DWORD dwStyle);
DWORD ShowAboutDialog(HWND hwnd);

/* _CAO\AΘbIɌyA쐬֐ */
DWORD generateGpgKey(HWND hwnd, LPCSTR szGpgHome, PSTRLIST pslSecRing, PSTRLIST pslPubRing);

/* _CAO\AΘbIɌJҏW֐ */
DWORD editGpgKey(HWND hwnd, LPCSTR szGpgHome, PSTRLIST pslSecRing, PSTRLIST pslPubRing);

/* _CAO\AΘbIɌI֐ lpdwRet 0:cancel 1:pub 2:sym */
DWORD selectGpgKey(HWND hwnd, LPCSTR szGpgHome, PSTRLIST pslSecRing, PSTRLIST pslPubRing, PSTRLIST pslSelected, LPDWORD lpdwRet);

/* _CAO\AvZXAĎs֐ */
DWORD raiseupChainedProcess(HWND hwnd, PCHAINEDPROCESS_NODE pnode_head, PHANDLE phRead, PHANDLE phWrite);

DWORD zgpencrypt(HWND hwnd, PJANUS_FILELIST pjfl, BOOL fPublic);
DWORD zgpdecrypt(HWND hwnd, LPCSTR pszFilename, BOOL fPublic);

DWORD InterpretAndSendGpgMsg(HWND hwndmsg, LPCSTR pLine, HANDLE hWrite, LPCSTR pLine2);

#endif