/* JanusHSmain.c
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of JanusHS.
 *
 * JanusHS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include <windowsx.h>
#include <HTMLHELP.H>

#include "resource.h"
#include "util.h"
#include "gpgez.h"
#include "JanusHS.h"

#pragma comment(lib, "Comctl32.lib")
#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "version.lib")
#pragma comment(lib, "HTMLHELP.LIB")

HINSTANCE g_hInstance;
LPSTR g_lpCmdLine;
HWND g_hwnd;
HWND hStatic1, hStatic2, hEdit1;
WNDPROC defProcWndForStatic1;
WNDPROC defProcWndForStatic2;
DWORD cookieHelp = 0;

#define MAX_FILES 65530
#define IDB_CLOSE 1001
#define HELP_FILENAME "JanusHS.chm"

JANUS_GV gVar;
CRITICAL_SECTION cs;

static fInWindow = FALSE;
static BOOL hStatic1HL = FALSE, hStatic2HL = FALSE;

/*------------------------------------------------------------*/
/**
 * \fn static DWORD prepareKeypare(HWND hwnd);
 *
 * JÍgp邽߂̌yA̍쐬
 * Jt@C̓O[oϐ玝ĂĂ
 *
 */
static DWORD
prepareKeypare(HWND hwnd) {
  WIN32_FIND_DATA wfd;
  HANDLE hFind;
  DWORD dwErr = ERROR_SUCCESS;

  /* ݒtH_ꍇ͍쐬 */
  hFind = FindFirstFile(gVar.pConfDir, &wfd);
  if (hFind == INVALID_HANDLE_VALUE) {
    if (!CreateDirectory(gVar.pConfDir, NULL)) {
      dwErr = GetLastError();
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
  } else {
    FindClose(hFind);
    /* ݒtH_ƖOŁAtH_ȊỐit@CHjꍇ̓G[ */
    if (!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
      dwErr = ERROR_INVALID_DATA;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
  }

  dwErr = generateGpgKey(hwnd, gVar.pConfDir, gVar.secKey, gVar.pubKey);
  if (dwErr == ERROR_SUCCESS) {
    gVar.fPublic = TRUE;
  }
finish_func:
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn VOID clearGlobals(VOID)
 *
 * O[oϐ̒gNA֐
 *
 */
static VOID
clearGlobals(VOID) {
  gVar.pFileInput = NULL;
  gVar.pFileOutput = NULL;
  gVar.pKeySelected = NULL;
  gVar.secKey = NULL;
  gVar.pubKey = NULL;
  return;
}

/*------------------------------------------------------------*/
/**
 * \fn static BOOL@checkkeypare(VOID);
 *
 * JÍgp邽߂̌yA݂邩ǂ̊mF
 * ݂TRUEAłȂFALSEԂ
 *
 */
static BOOL
checkkeypare(VOID) {
  WIN32_FIND_DATA wfd;
  HANDLE hFind;
  DWORD dwErr = ERROR_SUCCESS;
  BOOL fPublic = FALSE;

  /* ݒtH_ȂΌJÍ͎gps */
  hFind = FindFirstFile(gVar.pConfDir, &wfd);
  if (hFind == INVALID_HANDLE_VALUE) {
    fPublic = FALSE;
    goto finish_func;
  }
  FindClose(hFind);

  /* ݒtH_ƓÕt@C݂ꍇAɏ󋵂[Ȃ̂ŃG[\ */
  if (!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
    fPublic = FALSE;
    dwErr = ERROR_INVALID_DATA;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }

  /* t@CȂAĂTCY0ȂΌJÍ͎gps */
  hFind = FindFirstFile(strlist_get_node(gVar.secKey, 0), &wfd);
  if (hFind == INVALID_HANDLE_VALUE) {
    fPublic = FALSE;
    goto finish_func;
  }
  FindClose(hFind);
  if ((wfd.nFileSizeHigh == 0) && (wfd.nFileSizeLow == 0)) {
    fPublic = FALSE;
    goto finish_func;
  }
  fPublic = TRUE;
finish_func:
  return fPublic;
}

/*------------------------------------------------------------*/
/**
 * \fn static BOOL initializeGlobals(VOID);
 *
 * O[oϐ̏
 *
 */
static BOOL
initializeGlobals(VOID) {
  DWORD dwErr = ERROR_SUCCESS;
  CHAR s[MAX_PATH + 1];

  clearGlobals();
  gVar.pHomeDir = NULL;
  gVar.pConfDir = NULL;
  if ((gVar.secKey = strlist_create()) == NULL) {
    dwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  if ((gVar.pubKey = strlist_create()) == NULL) {
    dwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  if (!GetModuleFileName(NULL, s, MAX_PATH)) {
    dwErr = GetLastError();
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  *(strryen((LPCSTR)s)) = '\0';
  if ((gVar.pHomeDir = STRDUP(s)) == NULL) {
    dwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  STRCPY(gVar.pHomeDir, s);
  STRCAT(s, "\\");
  STRCAT(s, CONFDIR);
  if ((gVar.pConfDir = STRDUP(s)) == NULL) {
    dwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  STRCPY(s, gVar.pConfDir);
  STRCAT(s, "\\");
  STRCAT(s, SECRETRING);
  if ((dwErr = strlist_add_node(gVar.secKey, s)) != ERROR_SUCCESS) {
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  STRCPY(s, gVar.pConfDir);
  STRCAT(s, "\\");
  STRCAT(s, PUBLICRING);
  if ((dwErr = strlist_add_node(gVar.pubKey, s)) != ERROR_SUCCESS) {
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  gVar.fPublic = checkkeypare();
finish_func:
  if (dwErr != ERROR_SUCCESS) {
    if (gVar.pHomeDir) FREE(gVar.pHomeDir);
    if (gVar.pConfDir) FREE(gVar.pConfDir);
    if (gVar.secKey) strlist_release(gVar.secKey);
    if (gVar.pubKey) strlist_release(gVar.pubKey);
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD listupFilesFromDrop(HDROP hDrop, PJANUS_FILELIST pjfl)
 *
 * hbvꂽt@CAJANUS_FILELIST\̂Ɋi[֐
 *
 */
DWORD
listupFilesFromDrop(HDROP hDrop, PJANUS_FILELIST pjfl) {
  UINT i, iCnt;
  LPSTR buff = NULL;
  UINT len, baselen, maxlen;
  DWORD dwErr = ERROR_SUCCESS;

  /* hbvꂽt@C𒲂ׂ */
  iCnt = DragQueryFile(hDrop, -1, NULL, 0);
  if (iCnt == 0) {
    dwErr = ERROR_INVALID_NAME;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }

  /* efBNg𒲂ׂ */
  baselen = DragQueryFile(hDrop, 0, NULL, 0);
  if (!(pjfl->basedir = (LPSTR)MALLOC(sizeof(CHAR) * (baselen + 1)))) {
    dwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  DragQueryFile(hDrop, 0, pjfl->basedir, baselen + 1);
  *(strryen(pjfl->basedir)) = '\0';
  baselen = STRLEN(pjfl->basedir);

  /* FIX ME [gtH_łꍇ̏ */

  /* hbvꂽt@C̍ő咷𒲂ׂ */
  maxlen = 0;
  for (i = 0; i < iCnt; i++) {
    len = DragQueryFile(hDrop, i, NULL, 0);
    maxlen = (maxlen < len) ? len : maxlen;
  }

  /* t@CgĂ̍Ɨpobt@m */
  if (!(buff = (LPSTR)MALLOC(sizeof(CHAR) * (maxlen + 2)))) {
    dwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }

  /* t@CXg쐬 */
  if (!(pjfl->files = strlist_create())) {
    dwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, dwErr);
    goto finish_func;
  }
  for (i = 0; i < iCnt; i++) {
    DragQueryFile(hDrop, i, buff, maxlen + 1);
    if (STRNCMP(pjfl->basedir, buff, baselen)) {
      dwErr = ERROR_INVALID_NAME;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
    if ((dwErr = strlist_add_node(pjfl->files, buff + baselen + 1)) != ERROR_SUCCESS) {
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
  }
finish_func:
  if (buff) FREE(buff);
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn LRESULT CALLBACK@procWndStatic1(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
 *
 * ̃X^eBbNRg[̃R[obN֐
 * t@C̃hbvꍇɁAhbvꂽt@CXgAbvÍ
 *
 */
LRESULT CALLBACK
procWndStatic1(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  if (uMsg == WM_DROPFILES) {
    JANUS_FILELIST jfl;
    DWORD dwErr = ERROR_SUCCESS;

    SetForegroundWindow(g_hwnd);
    Edit_SetText(hEdit1, "");
    ShowLineMessage(hEdit1, "Start Encryption");
    jfl.basedir = NULL;
    jfl.files = NULL;
    dwErr = listupFilesFromDrop((HDROP)wParam, &jfl);
    DragFinish((HDROP)wParam);
    if (dwErr != ERROR_SUCCESS) {
      ShowLineMessage(hEdit1, "Process Aborted");
      return 0L;
    }
    dwErr = zgpencrypt(hwnd, &jfl, gVar.fPublic);
    if (dwErr == ERROR_SUCCESS) {
      ShowLineMessage(hEdit1, "Process Completed");
    } else if (dwErr = ERROR_CANCELLED) {
      ShowLineMessage(hEdit1, "Process Cancelled");
    } else {
      ShowLineMessage(hEdit1, "Process Aborted");
    }
    ShowLineMessage(hEdit1, "Ready...");
    if (jfl.basedir) FREE(jfl.basedir);
    if (jfl.files) strlist_release(jfl.files);
    return 0L;
  } else {
    return CallWindowProc(defProcWndForStatic1, hwnd, uMsg, wParam, lParam);
  }
  return 0L;
}

/*------------------------------------------------------------*/
/**
 * \fn LRESULT CALLBACK@procWndStatic2(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
 *
 * ẼX^eBbNRg[̃R[obN֐
 * t@C̃hbvꍇɁAhbvꂽt@C𕜍
 *
 */
LRESULT CALLBACK
procWndStatic2(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  if (uMsg == WM_DROPFILES) {
    DWORD dwErr = ERROR_SUCCESS;
    CHAR buff[MAX_PATH + 1];
    HANDLE hFind;
    WIN32_FIND_DATA wfd;

    SetForegroundWindow(g_hwnd);
    Edit_SetText(hEdit1, "");
    ShowLineMessage(hEdit1, "Start Decryption");
    /* hbvꂽt@CłtH_ł肵ꍇ̓G[ */
    if (DragQueryFile((HDROP)wParam, -1, NULL, 0) != 1) {
      dwErr = ERROR_INVALID_NAME;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
    DragQueryFile((HDROP)wParam, 0, buff, MAX_PATH);
    hFind = FindFirstFile(buff, &wfd);
    if (hFind == INVALID_HANDLE_VALUE) {
      dwErr = GetLastError();
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
    FindClose(hFind);
    if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
      dwErr = ERROR_INVALID_NAME;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }

    /* G[ȂΕ */
    if (dwErr == ERROR_SUCCESS) {
      dwErr = zgpdecrypt(hwnd, buff, gVar.fPublic);
    }
  finish_func:
    if (dwErr == ERROR_SUCCESS) {
      ShowLineMessage(hEdit1, "Process Completed");
    } else if (dwErr = ERROR_CANCELLED) {
      ShowLineMessage(hEdit1, "Process Cancelled");
    } else {
      ShowLineMessage(hEdit1, "Process Aborted");
    }
    ShowLineMessage(hEdit1, "Ready...");

    return 0L;
  } else {
    return CallWindowProc(defProcWndForStatic2, hwnd, uMsg, wParam, lParam);
  }
  return 0L;
}

/*------------------------------------------------------------*/
/**
 * \fn static DWORD SelectFilesAndEncrypt(HWND hwnd);
 *
 * j[ŁuÍvIꍇ̏
 * JANUS_FILELIST\̂Ɋi[t@CIAÍ
 * tH_̑IłȂH
 *
 */
static DWORD
SelectFilesAndEncrypt(HWND hwnd) {
  JANUS_FILELIST jfl;
  OPENFILENAME ofn;
  CHAR files[MAX_FILES + 1];
  HANDLE hFind;
  WIN32_FIND_DATA wfd;
  DWORD dwErr = ERROR_SUCCESS;
  LPSTR p;

  jfl.basedir = NULL;
  jfl.files = NULL;
  files[0]= '\0';
  ZeroMemory(&ofn, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = hwnd;
  ofn.hInstance = g_hInstance;
  ofn.lpstrFilter = "All Files(*.*)\0*.*\0\0";
  ofn.lpstrFile = files;
  ofn.nMaxFile = MAX_FILES;
  ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER;
  if (GetOpenFileName(&ofn)) {
    if ((hFind = FindFirstFile(files, &wfd)) == INVALID_HANDLE_VALUE) {
      dwErr = GetLastError();
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
    FindClose(hFind);

    /* Iꂽt@CtH_łꍇ̓t@CIĂ */
    /* FIX ME [gtH_łꍇ̏ */
    if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
      if (!(jfl.basedir = (LPSTR)MALLOC(STRLEN(files) + 2))) {
        dwErr = ERROR_OUTOFMEMORY;
        DEBUGERROR(0, dwErr);
        goto finish_func;
      }
      STRCPY(jfl.basedir, files);
      p = files + STRLEN(files) + 1;
      if (!(jfl.files = strlist_create())) {
        dwErr = ERROR_OUTOFMEMORY;
        DEBUGERROR(0, dwErr);
        goto finish_func;
      }
      while (*p) {
        if ((dwErr = strlist_add_node(jfl.files, p)) != ERROR_SUCCESS) {
          DEBUGERROR(0, dwErr);
          goto finish_func;
        }
        p += STRLEN(p);
        p++;
      }
    } else {
      /* Iꂽt@Cʏt@C̏ꍇAPt@Cɑ΂鏈 */
      *strryen(files) = '\0';
      if (!(jfl.basedir = STRDUP(files))) {
        dwErr = ERROR_OUTOFMEMORY;
        DEBUGERROR(0, dwErr);
        goto finish_func;
      }
      if (!(jfl.files = strlist_create())) {
        dwErr = ERROR_OUTOFMEMORY;
        DEBUGERROR(0, dwErr);
        goto finish_func;
      }
      if ((dwErr = strlist_add_node(jfl.files, files + STRLEN(jfl.basedir) + 1)) != ERROR_SUCCESS) {
        DEBUGERROR(0, dwErr);
        goto finish_func;
      }
    }
    dwErr = zgpencrypt(hwnd, &jfl, gVar.fPublic);
  finish_func:
    if (jfl.basedir) FREE(jfl.basedir);
    if (jfl.files) strlist_release(jfl.files);
  } else {
    /* G[ */
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn static DWORD SelectFileAndDecrypt(HWND hwnd);
 *
 * j[ŁuvIꍇ̏
 * t@CIŁA
 *
 */
static DWORD
SelectFileAndDecrypt(HWND hwnd) {
  OPENFILENAME ofn;
  CHAR filename[MAX_PATH + 1];
  DWORD dwErr = ERROR_SUCCESS;

  filename[0]= '\0';
  ZeroMemory(&ofn, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = hwnd;
  ofn.hInstance = g_hInstance;
  ofn.lpstrFilter = "gpg Files(*.gpg)\0*.gpg\0All Files(*.*)\0*.*\0\0";
  ofn.lpstrFile = filename;
  ofn.nMaxFile = MAX_PATH;
  ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_EXPLORER;
  if (GetOpenFileName(&ofn)) {
    zgpdecrypt(hwnd, filename, gVar.fPublic);
  } else {
    /* G[ */
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn static LPCSTR GetParamStr(LPCSTR cp, LPSTR *ppbuff, LPDWORD lpdwErr)
 *
 */
static LPCSTR
GetParamStr(LPCSTR cp, LPSTR *ppbuff, LPDWORD lpdwErr) {
  LPCSTR cps, cpe, cr = NULL;
  LPSTR buff = NULL;

  *ppbuff = NULL;
  cps = cp;
  if (*cps == '"') {
    cps++;
    if (!(cpe = STRCHR(cps, '"'))) {
      *lpdwErr = ERROR_INVALID_DATA;
      DEBUGERROR(0, *lpdwErr);
      cr = NULL;
      goto finish_func;
    }
    cr = cpe + 1;
  } else {
    cpe = cps;
    while (*cpe > ' ') cpe++;
    cr = cpe;
  }

  if (!(buff = (LPSTR)MALLOC(cpe - cps + 1))) {
    *lpdwErr = ERROR_OUTOFMEMORY;
    DEBUGERROR(0, *lpdwErr);
    cr = NULL;
    goto finish_func;
  }
  STRNCPY(buff, cps, cpe - cps);
  *(buff + (cpe - cps)) = '\0';
  *lpdwErr = ERROR_SUCCESS;
  *ppbuff = buff;
finish_func:
  return cr;
}

/*------------------------------------------------------------*/
/**
 * \fn static VOID processCmdLine(HWND hwnd, LPCSTR lpCmdLine)
 *
 * R}hC̏
 *
 */
static VOID
processCmdLine(HWND hwnd, LPCSTR lpCmdLine) {
  LPCSTR cp, cpp;
  LPSTR pbuff = NULL;
  JANUS_FILELIST jfl;
  UINT baselen = 0;
  DWORD dwErr = ERROR_SUCCESS;

  jfl.basedir = NULL;
  jfl.files = NULL;

  /* R}hCXCb`L̊mF */
  cp = lpCmdLine;
  while (*cp == ' ') cp++;
  if (!*cp) goto finish_func; /* R}hCɎŵȂꍇ */
  if (*cp != '-') {
    /* R}hCɃXCb`΁AȌ̃p[^𖳎ĒʏN */
    MessageBox(hwnd, "Illegal CommandLine.\nFound no switch.", "Error", MB_OK);
    goto finish_func;
  }
  cp++;

  if ((*cp == 'e') && (*(cp + 1) == ' ')) {
    /* XCb`'e'̏ꍇ */
    cp++; while (*cp == ' ') cp++;
    if (!*cp) { /* t@C̎w肪Ȃ΃G[ */
      dwErr = ERROR_INVALID_DATA;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }

    /* ɂȂtH_𒲂ׂ邽߁Aŏ̃t@C擾 */
    cpp = cp;
    if (!(cp = GetParamStr(cp, &pbuff, &dwErr))) {
      goto finish_func;
    }
    /* tH_̐؂o */
    *strryen(pbuff) = '\0';

    /* jfl\̂Ƀf[^i[ */
    baselen = STRLEN(pbuff);
    if (!(jfl.basedir = STRDUP(pbuff))) {
      FREE(pbuff);
      dwErr = ERROR_OUTOFMEMORY;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }
    FREE(pbuff);

    /* t@Ci[pXg̏ */
    if (!(jfl.files = strlist_create())) {
      FREE(jfl.basedir);
      dwErr = ERROR_OUTOFMEMORY;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }

    /* t@CXgɊi[ */
    cp = cpp;
    while (cp = GetParamStr(cp, &pbuff, &dwErr)) {
      if (STRNCMPL(jfl.basedir, pbuff)) {
        dwErr = ERROR_INVALID_DATA;
        DEBUGERROR(0, dwErr);
        FREE(pbuff);
        FREE(jfl.basedir); jfl.basedir = NULL;
        strlist_release(jfl.files); jfl.files = NULL;
        goto finish_func;
      }
      if ((dwErr = strlist_add_node(jfl.files, pbuff + baselen + 1)) != ERROR_SUCCESS) {
        DEBUGERROR(0, dwErr);
        goto finish_func;
      }
      FREE(pbuff);
      while (*cp == ' ') cp++;
      if (!*cp) break;
    }
    if (dwErr != ERROR_SUCCESS) goto finish_func;
    zgpencrypt(hwnd, &jfl, gVar.fPublic);

    FREE(jfl.basedir); jfl.basedir = NULL;
    strlist_release(jfl.files); jfl.files = NULL;

    PostQuitMessage(0);
  } else if ((*cp == 'd') && (*(cp + 1) == ' ')) {
    cp++; while (*cp == ' ') cp++;
    if (!*cp) { /* t@C̎w肪Ȃ΃G[ */
      dwErr = ERROR_INVALID_DATA;
      DEBUGERROR(0, dwErr);
      goto finish_func;
    }

    if (!(cp = GetParamStr(cp, &pbuff, &dwErr))) {
      goto finish_func;
    }
    zgpdecrypt(hwnd, pbuff, gVar.fPublic);
    FREE(pbuff);
    PostQuitMessage(0);
  }
finish_func:
  if (pbuff) FREE(pbuff);
  if (jfl.basedir) FREE(jfl.basedir);
  if (jfl.files) strlist_release(jfl.files);
  return;
}

/*------------------------------------------------------------*/
/**
 * \fn static BOOL Cls_OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
 *
 * EChE̍쐬
 *
 */
static BOOL
Cls_OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct) {
  DWORD dwErr = ERROR_SUCCESS;
  HBITMAP hBitmap;
  RECT rc1, rc2, rc3, rc0, rc0c;
  UINT borderwidth = 0;

  InitCommonControls();
  CoInitialize(NULL);
  InitializeCriticalSection(&cs);

  /* X^eBbNRg[ɃC[W\ */
  hStatic1 = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES, "STATIC", "", WS_CHILD | WS_BORDER | WS_VISIBLE | SS_BITMAP, 0, 0, 120, 120, hwnd, NULL, g_hInstance, NULL);
  hBitmap = LoadBitmap(g_hInstance, MAKEINTRESOURCE(IDB_BITMAP_ENC));
  SendMessage(hStatic1, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBitmap);
  defProcWndForStatic1 = (WNDPROC) GetWindowLong(hStatic1, GWL_WNDPROC);
  SetWindowLong(hStatic1, GWL_WNDPROC, (LONG)procWndStatic1);
  GetWindowRect(hStatic1, &rc1);

  /* EX^eBbNRg[ɃC[W\ */
  hStatic2 = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES, "STATIC", "", WS_CHILD | WS_BORDER | WS_VISIBLE | SS_BITMAP, rc1.right - rc1.left, 0, 120, 120, hwnd, NULL, g_hInstance, NULL);
  hBitmap = LoadBitmap(g_hInstance, MAKEINTRESOURCE(IDB_BITMAP_DEC));
  SendMessage(hStatic2, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBitmap);
  defProcWndForStatic2 = (WNDPROC) GetWindowLong(hStatic2, GWL_WNDPROC);
  SetWindowLong(hStatic2, GWL_WNDPROC, (LONG)procWndStatic2);
  GetWindowRect(hStatic2, &rc2);

  /* bZ[W{bNX쐬 */
  hEdit1 = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_BORDER | WS_VISIBLE | WS_VSCROLL | ES_AUTOVSCROLL | ES_MULTILINE, 0, rc1.bottom - rc1.top, rc2.right - rc1.left, 80, hwnd, NULL, g_hInstance, NULL);
  SendMessage(hEdit1, WM_SETFONT, (WPARAM)GetStockObject(ANSI_VAR_FONT), 0L);
  ShowLineMessage(hEdit1, "Ready...");
  GetWindowRect(hEdit1, &rc3);

  GetWindowRect(hwnd, &rc0);
  GetClientRect(hwnd, &rc0c);
  borderwidth = (rc0.right - rc0.left - (rc0c.right - rc0c.left)) / 2;
  MoveWindow(hwnd, rc0.left, rc0.top, rc1.right - rc1.left + rc2.right - rc2.left + borderwidth * 2, rc3.bottom - rc1.top + (rc0.bottom - rc0.top) - (rc0c.bottom - rc0c.top), TRUE);

  if ((dwErr = initializeGlobals()) != ERROR_SUCCESS) {
    return FALSE;
  }

  /* wvVXe */
  HtmlHelp(NULL, NULL, HH_INITIALIZE, (DWORD) &cookieHelp);

  return TRUE;
}

/*------------------------------------------------------------*/
static void
Cls_OnDestroy(HWND hwnd) {
  HtmlHelp(NULL, NULL, HH_UNINITIALIZE, cookieHelp);
  PostQuitMessage(0);
  return;
}

/*------------------------------------------------------------*/
static void
Cls_OnClose(HWND hwnd) {
  DeleteCriticalSection(&cs);
  DestroyWindow(hwnd);
}

/*------------------------------------------------------------*/
static void
Cls_OnPaint(HWND hwnd) {

  return;
}

/*------------------------------------------------------------*/
void
Cls_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify) {
  switch(id) {
  case IDM_ENCRYPT:
    {
      SelectFilesAndEncrypt(hwnd);
    }
    break;
  case IDM_DECRYPT:
    {
      SelectFileAndDecrypt(hwnd);
    }
    break;
  case IDM_QUIT:
    {
      SendMessage(hwnd, WM_CLOSE, 0, 0L);
    }
    break;
  case IDM_EDIT_KEY:
    {
      if (!gVar.fPublic) {
        CHAR m_buff[MAX_PATH + 1];

        if (LoadString(g_hInstance, IDS_CONFIRM_GENERATEKEY, m_buff, MAX_PATH) == 0) {
          STRCPY(m_buff, "Create a GPG Key Pair");
        }
        if (MessageBox(hwnd, m_buff, "Confirmation", MB_YESNO | MB_ICONQUESTION) == IDNO) {
          break;
        }
        if (prepareKeypare(hwnd) != ERROR_SUCCESS) {
          break;
        }
      }
      editGpgKey(hwnd, gVar.pConfDir, gVar.secKey, gVar.pubKey);
    }
    break;
  case IDM_SHOW_HELP:
    {
      CHAR szHelpFilename[MAX_PATH + 1] = "";

      GetModuleFileName(NULL, szHelpFilename, MAX_PATH);
      *(strryen(szHelpFilename) + 1) = '\0';
      if (STRLEN(szHelpFilename) + STRLEN(HELP_FILENAME) > MAX_PATH) break;
      STRCAT(szHelpFilename, HELP_FILENAME);
      HtmlHelp(hwnd, szHelpFilename, HH_DISPLAY_TOC, 0);
    }
    break;
  case IDM_ABOUT:
    {
      ShowAboutDialog(hwnd);
    }
    break;
  }
}

/*------------------------------------------------------------*/
LRESULT CALLBACK
procWnd(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  switch (uMsg) {
    HANDLE_MSG(hwnd, WM_CREATE, Cls_OnCreate);
    HANDLE_MSG(hwnd, WM_DESTROY, Cls_OnDestroy);
    HANDLE_MSG(hwnd, WM_COMMAND, Cls_OnCommand);
    HANDLE_MSG(hwnd, WM_CLOSE, Cls_OnClose);
  case WM_PROCESSCMDLINE:processCmdLine(hwnd, (LPCSTR)lParam); break;
  default:
    return (DefWindowProc(hwnd, uMsg, wParam, lParam));
  }
  return 0L;
}

/*------------------------------------------------------------*/
int WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
  MSG msg;
  WNDCLASSEX wc;
  BOOL bRet;
  static CHAR szMainWindowClassName[] = "JanusHS";
  DWORD dwErr = ERROR_SUCCESS;

  g_hInstance = hInstance;
  g_lpCmdLine = lpCmdLine;

  ZeroMemory(&wc, sizeof(WNDCLASSEX));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = procWnd;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0; /* DLGWINDOWEXTRA */;
  wc.hInstance = hInstance;
  wc.hIcon = LoadImage(g_hInstance, MAKEINTRESOURCE(IDI_ICON2), IMAGE_ICON, 32, 32, LR_CREATEDIBSECTION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) COLOR_WINDOW;
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
  wc.lpszClassName = szMainWindowClassName;
  wc.hIconSm = LoadImage(g_hInstance, MAKEINTRESOURCE(IDI_ICON2), IMAGE_ICON, 16, 16, LR_CREATEDIBSECTION);
  RegisterClassEx(&wc);

  msg.hwnd = CreateWindow(szMainWindowClassName, "JanusHS", WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
  g_hwnd = msg.hwnd;

  ShowWindow(msg.hwnd, nCmdShow);
  UpdateWindow(msg.hwnd);

  if (STRLEN(lpCmdLine) > 0) PostMessage(msg.hwnd, WM_PROCESSCMDLINE, 0, (LPARAM)lpCmdLine);

  while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0) {
    if (bRet == -1) {
      MessageBox(msg.hwnd, "GetMessage Error", "Error", MB_OK);
      break;
    } else {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }
  return (int)msg.wParam;
}

/*------------------------------------------------------------*/
