/**
 * chainedcommands.c
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of JanusHS.
 *
 * JanusHS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include <windows.h>
#include "util.h"
#include "gpgez.h"
#include "JanusHS.h"
#include "resource.h"

extern HINSTANCE g_hInstance;

/*------------------------------------------------------------*/
/* Appendix */
/*------------------------------------------------------------*/
/**
 * \fn VOID unescapeTarMessage(LPSTR pLine);
 *
 * bsdtarGXP[vĂ܂ɖ߂֐iɓ{܂j
 * ̕KZȂ邽߁A㏑ŏĂ_ɒ
 *
 */
static VOID
unescapeTarMessage(LPSTR pLine) {
  LPSTR ps, pd;
  for (ps = pLine, pd = pLine; *ps; ps++) {
    if (*ps != '\\') {
      *pd = *ps;
    } else {
      ps++;
      if (*ps == '\\') {
        *pd = '\\';
      } else if (*ps == 'a') {
        *pd = '\a';
      } else if (*ps == 'b') {
        *pd = '\b';
      } else if (*ps == 'f') {
        *pd = '\f';
      } else if (*ps == 'n') {
        *pd = '\n';
      } else if (*ps == 't') {
        *pd = '\t';
      } else if ((*ps >= '0') && (*ps <= '9')) {
        *pd = (*ps - '0') * 64 + (*(ps + 1) - '0') * 8 + (*(ps + 2) - '0');
        ps += 2;
      }
    }
    pd++;
  }
  *pd = '\0';

  for (ps = pLine; *ps; ps++)
    ;
  while ((ps > pLine + 2) && (*(ps - 1) == '\n') && (*(ps - 2) == '\n')) {
    ps--;
    *ps = '\0';
  }
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD InterpretAndSendGpgMsg(HWND hwndmsg, LPCSTR pLine, HANDLE hWrite, LPCSTR pLine2);
 *
 * gpg̃bZ[WpLine߂Ahwndmsgɕ\
 * KvɉhWriteɏ݂s
 *
 */
DWORD
InterpretAndSendGpgMsg(HWND hwndmsg, LPCSTR pLine, HANDLE hWrite, LPCSTR pLine2) {
  DWORD dwMsg = 0;
  LPCSTR p1, p2;
  LPSTR pLine3;
  CHAR szLine[MAX_LINE + 1] = "[GNUPG:] ";
  DWORD dwErr = ERROR_SUCCESS;

  dwMsg = interpretGpgMsg(pLine);
  switch(dwMsg) {
  case GNUPG_GOODSIG:
    {
      INT i = 0;
      LoadString(g_hInstance, IDS_GPG_GOODSIG, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      STRNCPY(szLine + STRLEN(szLine), ": ", MAX_LINE - STRLEN(szLine) - 1);
      for (i = 0, p1 = pLine; i < 3; i++) {
        if (!(p1 = STRCHR(p1, ' '))) break;
        p1++;
      }
      if (!p1) {
        ShowLineMessage(hwndmsg, "Error: Illegal Output From GNUPG");
        break;
      }
      if (!(pLine3 = unescapeutf82sjis(p1))) {
        ShowLineMessage(hwndmsg, "Error: OUT OF MEMORY");
        break;
      }
      STRNCPY(szLine + STRLEN(szLine), pLine3, MAX_LINE - STRLEN(szLine) - 1);
      FREE(pLine3);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_BADSIG:
    {
      INT i = 0;
      LoadString(g_hInstance, IDS_GPG_BADSIG, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      STRNCPY(szLine + STRLEN(szLine), ": ", MAX_LINE - STRLEN(szLine) - 1);
      for (i = 0, p1 = pLine; i < 3; i++) {
        if (!(p1 = STRCHR(p1, ' '))) break;
        p1++;
      }
      if (!p1) {
        ShowLineMessage(hwndmsg, "Error: Illegal Output From GNUPG");
        break;
      }
      if (!(pLine3 = unescapeutf82sjis(p1))) {
        ShowLineMessage(hwndmsg, "Error: OUT OF MEMORY");
        break;
      }
      STRNCPY(szLine + STRLEN(szLine), pLine3, MAX_LINE - STRLEN(szLine) - 1);
      FREE(pLine3);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_ERRSIG:
    {
      LoadString(g_hInstance, IDS_GPG_ERRSIG, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_VALIDSIG:
    {
      INT i = 0;
      STRNCPY(szLine + STRLEN(szLine), "FINGERPRINT : ", MAX_LINE - STRLEN(szLine) - 1);
      for (i = 0, p1 = pLine; i < 2; i++) {
        if (!(p1 = STRCHR(p1, ' '))) break;
        p1++;
      }
      if (!p1) {
        ShowLineMessage(hwndmsg, "Error: Illegal Output From GNUPG");
        break;
      }
      if (!(p2 = STRCHR(p1, ' '))) {
        ShowLineMessage(hwndmsg, "Error: Illegal Output From GNUPG");
        break;
      }
      STRNCPY(szLine + STRLEN(szLine), p1, p2 - p1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_GET_BOOL:
    {
      DWORD dwWritten;

      if (!pLine2) {
        if (MessageBox(hwndmsg, pLine + STRLEN("[GNUPG:] GET_BOOL "), "GET BOOL", MB_YESNO) == IDYES) {
          WriteFile(hWrite, "y\n", STRLEN("y\n"), &dwWritten, NULL);
        } else {
          WriteFile(hWrite, "n\n", STRLEN("n\n"), &dwWritten, NULL);
        }
      } else {
        WriteFile(hWrite, pLine2, STRLEN(pLine2), &dwWritten, NULL);
        WriteFile(hWrite, "\n", STRLEN("\n"), &dwWritten, NULL);
      }
    }
    break;
  case GNUPG_GET_LINE:
    {
      CHAR pInput[MAX_PATH + 1] = "";
      DWORD dwWritten;

      if (!pLine2) {
        dwErr = InputBoxEx(hwndmsg, pLine + STRLEN("[GNUPG:] GET_LINE "), "GET LINE", pInput, MAX_PATH, INPUTBOX_WITHCANCEL);
        if (dwErr == ERROR_SUCCESS) {
          WriteFile(hWrite, pInput, STRLEN(pInput), &dwWritten, NULL);
          WriteFile(hWrite, "\n", STRLEN("\n"), &dwWritten, NULL);
        }
      } else {
        WriteFile(hWrite, pLine2, STRLEN(pLine2), &dwWritten, NULL);
        WriteFile(hWrite, "\n", STRLEN("\n"), &dwWritten, NULL);
      }
    }
    break;
  case GNUPG_GET_HIDDEN:
    {
      CHAR pPassphrase[MAX_PATH + 1] = "";
      DWORD dwWritten;

      if (!pLine2) {
        dwErr = InputBoxEx(hwndmsg, pLine + STRLEN("[GNUPG:] GET_HIDDEN "), "GET HIDDEN", pPassphrase, MAX_PATH, INPUTBOX_SECRET | INPUTBOX_WITHCANCEL);
        if (dwErr == ERROR_SUCCESS) {
          WriteFile(hWrite, pPassphrase, STRLEN(pPassphrase), &dwWritten, NULL);
          WriteFile(hWrite, "\n", STRLEN("\n"), &dwWritten, NULL);
        }
      } else {
        WriteFile(hWrite, pLine2, STRLEN(pLine2), &dwWritten, NULL);
        WriteFile(hWrite, "\n", STRLEN("\n"), &dwWritten, NULL);
      }
    }
    break;
  case GNUPG_NEED_PASSPHRASE:
    {
      LoadString(g_hInstance, IDS_GPG_NEEDPASSPHRASE, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_NEED_PASSPHRASE_SYM:
    {
      LoadString(g_hInstance, IDS_GPG_NEEDPASSPHRASESYM, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_MISSING_PASSPHRASE:
    {
      LoadString(g_hInstance, IDS_GPG_MISSINGPASSPHRASE, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_BAD_PASSPHRASE:
    {
      LoadString(g_hInstance, IDS_GPG_BADPASSPHRASE, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_GOOD_PASSPHRASE:
    {
      LoadString(g_hInstance, IDS_GPG_GOODPASSPHRASE, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_DECRYPTION_FAILED:
    {
      LoadString(g_hInstance, IDS_GPG_DECRYPTIONFAILED, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_NO_PUBKEY:
    {
      LoadString(g_hInstance, IDS_GPG_NOPUBKEY, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_NO_SECKEY:
    {
      LoadString(g_hInstance, IDS_GPG_NOSECKEY, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_IMPORTED:
    {
      INT i = 0;
      LoadString(g_hInstance, IDS_GPG_IMPORTED, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      STRNCPY(szLine + STRLEN(szLine), ": ", MAX_LINE - STRLEN(szLine) - 1);
      for (i = 0, p1 = pLine; i < 3; i++) {
        if (!(p1 = STRCHR(p1, ' '))) break;
        p1++;
      }
      if (!p1) {
        ShowLineMessage(hwndmsg, "Error: Illegal Output From GNUPG");
        break;
      }
      if (!(pLine3 = unescapeutf82sjis(p1))) {
        ShowLineMessage(hwndmsg, "Error: OUT OF MEMORY");
        break;
      }
      STRNCPY(szLine + STRLEN(szLine), pLine3, MAX_LINE - STRLEN(szLine) - 1);
      FREE(pLine3);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_IMPORT_OK:
    {
      INT i = 0, j = 0;
      for (i = 0, p1 = pLine; i < 2; i++) {
        if (!(p1 = STRCHR(p1, ' '))) break;
        p1++;
      }
      if (!p1) {
        ShowLineMessage(hwndmsg, "Error: illegal Output From GNUPG");
        break;
      }
      while (*p1 >= '0' && *p1 <= '9') {
        j *= 10;
        j += (*p1 - '0');
        p1++;
      }
      if (j == 0) {
        LoadString(g_hInstance, IDS_GPG_IMPORTOK0, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      } else if (j & 1) {
        LoadString(g_hInstance, IDS_GPG_IMPORTOK1, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      } else {
        LoadString(g_hInstance, IDS_GPG_IMPORTOK2, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      }
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_IMPORT_PROBLEM:
    {
      LoadString(g_hInstance, IDS_GPG_IMPORTPROBLEM, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_BEGIN_DECRYPTION:
    {
      LoadString(g_hInstance, IDS_GPG_BEGINDECRYPTION, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_END_DECRYPTION:
    {
      LoadString(g_hInstance, IDS_GPG_ENDDECRYPTION, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_BEGIN_ENCRYPTION:
    {
      LoadString(g_hInstance, IDS_GPG_BEGINENCRYPTION, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_END_ENCRYPTION:
    {
      LoadString(g_hInstance, IDS_GPG_ENDENCRYPTION, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_DELETE_PROBLEM:
    {
      INT i = 0;
      for (i = 0, p1 = pLine; i < 2; i++) {
        if (!(p1 = STRCHR(p1, ' '))) break;
        p1++;
      }
      if (!p1) {
        ShowLineMessage(hwndmsg, "Error: Illegal Output From GNUPG");
        break;
      }
      if (*p1 == '1') {
        LoadString(g_hInstance, IDS_GPG_DELETEPROBLEM1, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      } else if (*p1 == '2') {
        LoadString(g_hInstance, IDS_GPG_DELETEPROBLEM2, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      } else if (*p1 == '3') {
        LoadString(g_hInstance, IDS_GPG_DELETEPROBLEM3, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      } else {
        STRCPY(szLine, "Error: Illegal Output From GNUPG");
      }
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_SIG_CREATED:
    {
      LoadString(g_hInstance, IDS_GPG_SIGCREATED, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_KEY_CREATED:
    {
      LoadString(g_hInstance, IDS_GPG_KEYCREATED, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_KEY_NOT_CREATED:
    {
      LoadString(g_hInstance, IDS_GPG_KEYNOTCREATED, szLine + STRLEN(szLine), MAX_LINE - STRLEN(szLine) - 1);
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_NODATA:
    {
      STRCAT(szLine, "NO DATA");
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_UNEXPECTED:
    {
      STRCAT(szLine, "UNEXPECTED ERROR");
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  case GNUPG_ERROR:
    {
      STRCAT(szLine, "Error occurred");
      ShowLineMessage(hwndmsg, szLine);
    }
    break;
  default:
    break;
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/* For Archive */
/*------------------------------------------------------------*/
/**
 * \fn DWORD initializeTarParam(PTAR_PARAM ptparam, LPCSTR pBaseDirectory, PSTRLIST pFiles)
 *
 * bsdtar.exe̎sɕKvȏێ\PTAR_PARAM̏
 *
 */
DWORD
initializeTarParam(PTAR_PARAM ptparam, LPCSTR pBaseDirectory, PSTRLIST pFiles) {
  ptparam->basedir = pBaseDirectory;
  ptparam->files = pFiles;
  ptparam->hStdErr = INVALID_HANDLE_VALUE;
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD startupTar(LPVOID buff)
 *
 * bsdtar.exe̋Np֐
 * bsdtarɂĂ͕WG[o͂Ď̂ŁÂ߂̃pCvݒ肵ŃR}hs
 *
 */
DWORD
startupTar(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PTAR_PARAM ptparam = (PTAR_PARAM)pp->buff;
  HANDLE hStdErrC = INVALID_HANDLE_VALUE;
  DWORD dwErr = ERROR_SUCCESS;

  if ((dwErr = CreateReadPipe(&(ptparam->hStdErr), &hStdErrC)) != ERROR_SUCCESS) {
    goto finish_func;
  }
  if ((dwErr = gpgez_tar(ptparam->basedir, ptparam->files, pp->hWrite, hStdErrC, &(pp->hProcess))) != ERROR_SUCCESS) goto finish_func;
  CloseHandleClean(&hStdErrC);
  pp->phObserve = &(ptparam->hStdErr);
finish_func:
  if (dwErr != ERROR_SUCCESS) {
    if (ptparam->hStdErr != INVALID_HANDLE_VALUE) CloseHandleClean(&(ptparam->hStdErr));
  }
  if (hStdErrC != INVALID_HANDLE_VALUE) CloseHandleClean(&hStdErrC);
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD procObservedTar(LPVOID buff, HWND hwndmsg)
 *
 * bsdtar.exe̎sĎp֐
 * bsdtar.exeWG[o͂ɉ݂ꍇɃR[
 * _ł̓bZ[Wp̃GfBbgRg[bsdtar.exe̕o
 *
 */
DWORD
procObservedTar(LPVOID buff, HWND hwndmsg) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PTAR_PARAM ptparam = (PTAR_PARAM)pp->buff;
  CHAR szLine[MAX_LINE + 8 + 1];
  DWORD dwErr = ERROR_SUCCESS;

  STRCPY(szLine, "[TAR:] ");
  dwErr = ReadPipeLine(&(ptparam->hStdErr), szLine + 7, MAX_LINE);
  if ((dwErr != ERROR_SUCCESS) && (dwErr != ERROR_HANDLE_EOF)) {
    goto finish_func;
  }
  if ((szLine[7] == 'a') && (szLine[8] == ' ')) { /* ڏȓ̃bZ[W\ */
    LPSTR pc;
    for (pc = szLine + 7; *(pc + 2); pc++) {
      *pc = *(pc + 2);
    }
    *pc = '\0';
  }
  if (dwErr == ERROR_HANDLE_EOF) {
    dwErr = ERROR_SUCCESS;
  }
  unescapeTarMessage(szLine);
  ShowLineMessage(hwndmsg, szLine);
finish_func:
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD finishupTar(LPVOID buff)
 *
 * bsdtar.exeǏn
 * ĎpɊJĂWG[o͗p̃pCv
 *
 */
DWORD
finishupTar(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PTAR_PARAM ptar = (PTAR_PARAM)pp->buff;

  if (ptar->hStdErr != INVALID_HANDLE_VALUE) CloseHandleClean(&(ptar->hStdErr));
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/* For UnArchive */
/*------------------------------------------------------------*/
/**
 * \fn DWORD initializeUntarParam(PUNTAR_PARAM puparam, LPCSTR pBaseDirectory, PSTRLIST pFiles)
 *
 * bsdtar.exe̎sɕKvȏێ\PUNTAR_PARAM̏
 *
 */
DWORD
initializeUntarParam(PUNTAR_PARAM puparam, LPCSTR pBaseDirectory, BOOL fOverwrite) {
  puparam->basedir = pBaseDirectory;
  puparam->hStdErr = INVALID_HANDLE_VALUE;
  puparam->fOverwrite = fOverwrite;
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD startupUntar(LPVOID buff)
 *
 * bsdtar.exe̋Np֐
 * bsdtarɂĂ͕WG[o͂Ď̂ŁÂ߂̃pCvݒ肵ŃR}hs
 *
 */
DWORD
startupUntar(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PUNTAR_PARAM puparam = (PUNTAR_PARAM)pp->buff;
  HANDLE hStdErrC = INVALID_HANDLE_VALUE;
  DWORD dwErr = ERROR_SUCCESS;

  if ((dwErr = CreateReadPipe(&(puparam->hStdErr), &hStdErrC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = gpgez_untar(puparam->basedir, pp->hRead, hStdErrC, puparam->fOverwrite, &(pp->hProcess))) != ERROR_SUCCESS) goto finish_func;
  CloseHandleClean(&hStdErrC);
  pp->phObserve = &(puparam->hStdErr);
finish_func:
  if (dwErr != ERROR_SUCCESS) {
    if (puparam->hStdErr != INVALID_HANDLE_VALUE) CloseHandleClean(&(puparam->hStdErr));
  }
  if (hStdErrC != INVALID_HANDLE_VALUE) CloseHandleClean(&hStdErrC);
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD procObservedUntar(LPVOID buff, HWND hwndmsg)
 *
 * bsdtar.exe̎sĎp֐
 * bsdtar.exeWG[o͂ɉ݂ꍇɃR[
 * _ł̓bZ[Wp̃GfBbgRg[bsdtar.exe̕o
 *
 */
DWORD
procObservedUntar(LPVOID buff, HWND hwndmsg) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PUNTAR_PARAM puparam = (PUNTAR_PARAM)pp->buff;
  CHAR szLine[MAX_LINE + 8 + 1];
  DWORD dwErr = ERROR_SUCCESS;

  STRCPY(szLine, "[TAR:] ");
  dwErr = ReadPipeLine(&(puparam->hStdErr), szLine + 7, MAX_LINE);
  if ((dwErr != ERROR_SUCCESS) && (dwErr != ERROR_HANDLE_EOF)) {
    goto finish_func;
  }
  if ((szLine[7] == 'x') && (szLine[8] == ' ')) { /* ڏȓ̃G[bZ[W\ */
    LPSTR pc;
    pc = STRCHR(szLine + 8, ':');
    if ((pc) && STRNCMPL(" Can't set permissions: Function not implemented", pc)) {
      *pc = '\n';
      *(pc + 1) = '\0';
    }
    for (pc = szLine + 7; *(pc + 2); pc++) {
      *pc = *(pc + 2);
    }
    *pc = '\0';
  }
  if (dwErr == ERROR_HANDLE_EOF) {
    dwErr = ERROR_SUCCESS;
  }
  unescapeTarMessage(szLine);
  ShowLineMessage(hwndmsg, szLine);
finish_func:
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD finishupUntar(LPVOID buff)
 *
 * bsdtar.exeǏn
 * ĎpɊJĂWG[o͗p̃pCv
 *
 */
DWORD
finishupUntar(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PUNTAR_PARAM puntar = (PUNTAR_PARAM)pp->buff;

  if (puntar->hStdErr != INVALID_HANDLE_VALUE) CloseHandleClean(&(puntar->hStdErr));
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/* For Import Keys */
/*------------------------------------------------------------*/
/**
 * \fn DWORD initializeGpgImportParam(PGPGIMPORT_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey)
 *
 * C|[ĝ߂gpg.exeN̂ɕKvȏێ\GPGIMPORT_PARAM̏
 *
 */
DWORD
initializeGpgImportParam(PGPGIMPORT_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey) {
  pgparam->pszGpgHome = pConfDir;
  pgparam->pSecRing = pSecKey;
  pgparam->pPubRing = pPubKey;
  pgparam->hCommand = INVALID_HANDLE_VALUE;
  pgparam->hStatus = INVALID_HANDLE_VALUE;
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD startupGpgImport(LPVOID buff)
 *
 * gpg.exe --import ̋Np֐
 * --command-fd  --status-fd ̂߂̃pCvݒ肵ŃR}hs
 *
 */
DWORD
startupGpgImport(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGIMPORT_PARAM pgparam = (PGPGIMPORT_PARAM)pp->buff;
  HANDLE hCommandC = INVALID_HANDLE_VALUE;
  HANDLE hStatusC = INVALID_HANDLE_VALUE;
  DWORD dwErr = ERROR_SUCCESS;

  if ((dwErr = CreateWritePipe(&(pgparam->hCommand), &hCommandC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = CreateReadPipe(&(pgparam->hStatus), &hStatusC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = gpgez_import(pgparam->pszGpgHome, pgparam->pSecRing, pgparam->pPubRing, pp->hRead, hCommandC, hStatusC, &(pp->hProcess))) != ERROR_SUCCESS) goto finish_func;
  CloseHandleClean(&hCommandC);
  CloseHandleClean(&hStatusC);
  pp->phObserve = &(pgparam->hStatus);
finish_func:
  if (dwErr != ERROR_SUCCESS) {
    if (hCommandC != INVALID_HANDLE_VALUE) CloseHandleClean(&hCommandC);
    if (hStatusC != INVALID_HANDLE_VALUE) CloseHandleClean(&hStatusC);
    if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
    if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD procObservedGpgImport(LPVOID buff, HWND hwndmsg)
 *
 * gpg.exe --import ̎sĎp֐
 * gpg.exestatus-fdɉ݂ꍇɃR[
 * _łgpg.exe̕sjisɕϊăbZ[Wp̃GfBbgRg[ɏo
 *
 */
DWORD
procObservedGpgImport(LPVOID buff, HWND hwndmsg) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGIMPORT_PARAM pgparam = (PGPGIMPORT_PARAM)pp->buff;
  LPSTR psjis = NULL;
  CHAR szLine[MAX_LINE + 1];
  DWORD dwAvail = 0, dwErr = ERROR_SUCCESS;

  dwErr = ReadPipeLine(&(pgparam->hStatus), szLine, MAX_LINE);
  if ((dwErr != ERROR_SUCCESS) && (dwErr != ERROR_HANDLE_EOF)) {
    goto finish_func;
  }
  if (dwErr == ERROR_HANDLE_EOF) {
    dwErr = ERROR_SUCCESS;
  }
  dwErr = InterpretAndSendGpgMsg(hwndmsg, szLine, NULL, NULL);
finish_func:
  if (psjis) FREE(psjis);
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD finishupGpgImport(LPVOID buff)
 *
 * gpg.exeǏn
 * ĎpɊJĂstatus-fdcommand-fdp̃pCv
 *
 */
DWORD
finishupGpgImport(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGIMPORT_PARAM pgparam = (PGPGIMPORT_PARAM)pp->buff;

  if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hStatus));
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/* For Delete Keys */
/*------------------------------------------------------------*/
/**
 * \fn DWORD initializeGpgDeleteParam(PGPGDELETE_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey, LPCSTR pFpr)
 *
 * f[ĝ߂gpg.exeN̂ɕKvȏێ\GPGDELETE_PARAM̏
 *
 */
DWORD
initializeGpgDeleteParam(PGPGDELETE_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey, LPCSTR pFpr) {
  pgparam->pszGpgHome = pConfDir;
  pgparam->pSecRing = pSecKey;
  pgparam->pPubRing = pPubKey;
  pgparam->pFpr = pFpr;
  pgparam->hCommand = INVALID_HANDLE_VALUE;
  pgparam->hStatus = INVALID_HANDLE_VALUE;
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD startupGpgDelete(LPVOID buff)
 *
 * gpg.exe --delete ̋Np֐
 * --command-fd  --status-fd ̂߂̃pCvݒ肵ŃR}hs
 *
 */
DWORD
startupGpgDelete(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGDELETE_PARAM pgparam = (PGPGDELETE_PARAM)pp->buff;
  HANDLE hCommandC = INVALID_HANDLE_VALUE;
  HANDLE hStatusC = INVALID_HANDLE_VALUE;
  DWORD dwErr = ERROR_SUCCESS;

  if ((dwErr = CreateWritePipe(&(pgparam->hCommand), &hCommandC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = CreateReadPipe(&(pgparam->hStatus), &hStatusC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = gpgez_delete(pgparam->pszGpgHome, pgparam->pPubRing, pgparam->pFpr, hCommandC, hStatusC, &(pp->hProcess))) != ERROR_SUCCESS) goto finish_func;
  CloseHandleClean(&hCommandC);
  CloseHandleClean(&hStatusC);
  pp->phObserve = &(pgparam->hStatus);
finish_func:
  if (dwErr != ERROR_SUCCESS) {
    if (hCommandC != INVALID_HANDLE_VALUE) CloseHandleClean(&hCommandC);
    if (hStatusC != INVALID_HANDLE_VALUE) CloseHandleClean(&hStatusC);
    if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
    if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD procObservedGpgDelete(LPVOID buff, HWND hwndmsg)
 *
 * gpg.exe --delete ̎sĎp֐
 * gpg.exestatus-fdɉ݂ꍇɃR[
 * _łgpg.exe̕sjisɕϊăbZ[Wp̃GfBbgRg[ɏo
 * G[ȂΉ\ȂH
 *
 */
DWORD
procObservedGpgDelete(LPVOID buff, HWND hwndmsg) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGDELETE_PARAM pgparam = (PGPGDELETE_PARAM)pp->buff;
  LPSTR psjis = NULL;
  CHAR szLine[MAX_LINE + 1];
  DWORD dwAvail = 0, dwErr = ERROR_SUCCESS;

  dwErr = ReadPipeLine(&(pgparam->hStatus), szLine, MAX_LINE);
  if ((dwErr != ERROR_SUCCESS) && (dwErr != ERROR_HANDLE_EOF)) {
    goto finish_func;
  }
  if (dwErr == ERROR_HANDLE_EOF) {
    dwErr = ERROR_SUCCESS;
  }
  dwErr = InterpretAndSendGpgMsg(hwndmsg, szLine, NULL, NULL);
finish_func:
  if (psjis) FREE(psjis);
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD finishupGpgDelete(LPVOID buff)
 *
 * gpg.exeǏn
 * ĎpɊJĂstatus-fdcommand-fdp̃pCv
 *
 */
DWORD
finishupGpgDelete(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGDELETE_PARAM pgparam = (PGPGDELETE_PARAM)pp->buff;

  if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hStatus));
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/* For Decrypt */
/*------------------------------------------------------------*/
/**
 * \fn DWORD initializeGpgDecryptParam(PGPGDECRYPT_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey, BOOL fVerify, LPSTR pPassphrase, LPSTR pPassphraseSym)
 *
 * f[^̂߂gpg.exeN̂ɕKvȏێ\GPGDECRYPT_PARAM̏
 *
 */
DWORD
initializeGpgDecryptParam(PGPGDECRYPT_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey, BOOL fVerify, LPSTR pPassphrase, LPSTR pPassphraseSym) {
  pgparam->pszGpgHome = pConfDir;
  pgparam->pSecRing = pSecKey;
  pgparam->pPubRing = pPubKey;
  pgparam->fVerify = fVerify;
  pgparam->hCommand = INVALID_HANDLE_VALUE;
  pgparam->hStatus = INVALID_HANDLE_VALUE;
  pgparam->pPassphrase = pPassphrase;
  pgparam->pPassphraseSym = pPassphrase;
  pgparam->pLine2 = NULL;
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD startupGpgDecrypt(LPVOID buff)
 *
 * gpg.exe --decrypt ̋Np֐
 * --command-fd  --status-fd ̂߂̃pCvݒ肵ŃR}hs
 *
 */
DWORD
startupGpgDecrypt(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGDECRYPT_PARAM pgparam = (PGPGDECRYPT_PARAM)pp->buff;
  HANDLE hCommandC = INVALID_HANDLE_VALUE;
  HANDLE hStatusC = INVALID_HANDLE_VALUE;
  DWORD dwErr = ERROR_SUCCESS;

  if ((dwErr = CreateWritePipe(&(pgparam->hCommand), &hCommandC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = CreateReadPipe(&(pgparam->hStatus), &hStatusC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = gpgez_decrypt(pgparam->pszGpgHome, pgparam->pSecRing, pgparam->pPubRing, pgparam->fVerify ? FALSE : TRUE, pp->hRead, pp->hWrite, hCommandC, hStatusC, &(pp->hProcess))) != ERROR_SUCCESS) goto finish_func;
  CloseHandleClean(&hCommandC);
  CloseHandleClean(&hStatusC);
  pp->phObserve = &(pgparam->hStatus);
finish_func:
  if (dwErr != ERROR_SUCCESS) {
    if (hCommandC != INVALID_HANDLE_VALUE) CloseHandleClean(&hCommandC);
    if (hStatusC != INVALID_HANDLE_VALUE) CloseHandleClean(&hStatusC);
    if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
    if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD procObservedGpgDecrypt(LPVOID buff, HWND hwndmsg)
 *
 * gpg.exe --decrypt ̎sĎp֐
 * gpg.exestatus-fdɉ݂ꍇɃR[
 *
 */
DWORD
procObservedGpgDecrypt(LPVOID buff, HWND hwndmsg) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGDECRYPT_PARAM pgparam = (PGPGDECRYPT_PARAM)pp->buff;
  CHAR szLine[MAX_LINE + 1];
  DWORD dwErr = ERROR_SUCCESS;

  dwErr = ReadPipeLine(&(pgparam->hStatus), szLine, MAX_LINE);
  if ((dwErr != ERROR_SUCCESS) && (dwErr != ERROR_HANDLE_EOF)) {
    goto finish_func;
  }
  if (dwErr = ERROR_HANDLE_EOF) {
    dwErr = ERROR_SUCCESS;
  }
  dwErr = InterpretAndSendGpgMsg(hwndmsg, szLine, pgparam->hCommand, pgparam->pLine2);
  if (!STRNCMPL("[GNUPG:] NEED_PASSPHRASE ", szLine)) {
    pgparam->pLine2 = pgparam->pPassphrase;
  } else if (!STRNCMPL("[GNUPG:] NEED_PASSPHRASE_SYM ", szLine)) {
    pgparam->pLine2 = pgparam->pPassphraseSym;
  } else if (!STRNCMPL("[GNUPG:] BAD_PASSPHRASE", szLine)) {
    dwErr = ERROR_INVALID_DATA;
  } else if (!STRNCMPL("[GNUPG:] MISSING_PASSPHRASE", szLine)) {
    dwErr = ERROR_INVALID_DATA;
  } else if (!STRNCMPL("[GNUPG:] GET_HIDDEN ", szLine)) {
    pgparam->pLine2 = NULL;
  }
finish_func:
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD finishupGpgDecrypt(LPVOID buff)
 *
 * gpg.exeǏn
 * ĎpɊJĂstatus-fdcommand-fdp̃pCv
 *
 */
DWORD
finishupGpgDecrypt(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGDECRYPT_PARAM pgparam = (PGPGDECRYPT_PARAM)pp->buff;

  if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hStatus));
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/* For Encrypt */
/*------------------------------------------------------------*/
/**
 * \fn DWORD initializeGpgEncryptParam(PGPGENCRYPT_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey, PSTRLIST pRecipients, LPSTR pPassphrase, LPSTR pPassphraseSym)
 *
 * f[^Í̂߂gpg.exeN̂ɕKvȏێ\GPGDECRYPT_PARAM̏
 *
 */
DWORD
initializeGpgEncryptParam(PGPGENCRYPT_PARAM pgparam, LPCSTR pConfDir, PSTRLIST pSecKey, PSTRLIST pPubKey, PSTRLIST pRecipients, LPSTR pPassphrase, LPSTR pPassphraseSym) {
  pgparam->pszGpgHome = pConfDir;
  pgparam->pSecRing = pSecKey;
  pgparam->pPubRing = pPubKey;
  pgparam->pFpr = pRecipients;
  pgparam->pPassphraseSym = pPassphraseSym;
  pgparam->hCommand = INVALID_HANDLE_VALUE;
  pgparam->hStatus = INVALID_HANDLE_VALUE;
  pgparam->pPassphrase = pPassphrase;
  pgparam->pPassphraseSym = pPassphraseSym;
  pgparam->pLine2 = NULL;
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD startupGpgEncrypt(LPVOID buff)
 *
 * gpg.exe --encrypt ̋Np֐
 * --command-fd  --status-fd ̂߂̃pCvݒ肵ŃR}hs
 *
 */
DWORD
startupGpgEncrypt(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGENCRYPT_PARAM pgparam = (PGPGENCRYPT_PARAM)pp->buff;
  HANDLE hCommandC = INVALID_HANDLE_VALUE;
  HANDLE hStatusC = INVALID_HANDLE_VALUE;
  DWORD dwErr = ERROR_SUCCESS;

  if ((dwErr = CreateWritePipe(&(pgparam->hCommand), &hCommandC)) != ERROR_SUCCESS) goto finish_func;
  if ((dwErr = CreateReadPipe(&(pgparam->hStatus), &hStatusC)) != ERROR_SUCCESS) goto finish_func;
  if (!pgparam->pPassphraseSym) {
    if ((dwErr = gpgez_encrypt(pgparam->pszGpgHome, pgparam->pSecRing, pgparam->pPubRing, FALSE, pgparam->pFpr, pp->hRead, pp->hWrite, hCommandC, hStatusC, &(pp->hProcess))) != ERROR_SUCCESS) goto finish_func;
  } else {
    if ((dwErr = gpgez_encrypt_sym(pgparam->pszGpgHome, pgparam->pSecRing, pgparam->pPubRing, TRUE, pp->hRead, pp->hWrite, hCommandC, hStatusC, &(pp->hProcess))) != ERROR_SUCCESS) goto finish_func;
  }
  CloseHandleClean(&hCommandC);
  CloseHandleClean(&hStatusC);
  pp->phObserve = &(pgparam->hStatus);
finish_func:
  if (dwErr != ERROR_SUCCESS) {
    if (hCommandC != INVALID_HANDLE_VALUE) CloseHandleClean(&hCommandC);
    if (hStatusC != INVALID_HANDLE_VALUE) CloseHandleClean(&hStatusC);
    if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
    if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  }
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD procObservedGpgEncrypt(LPVOID buff, HWND hwndmsg)
 *
 * gpg.exe --encrypt ̎sĎp֐
 * gpg.exestatus-fdɉ݂ꍇɃR[
 *
 */
DWORD
procObservedGpgEncrypt(LPVOID buff, HWND hwndmsg) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGENCRYPT_PARAM pgparam = (PGPGENCRYPT_PARAM)pp->buff;
  LPSTR psjis = NULL;
  CHAR szLine[MAX_LINE + 1];
  DWORD dwAvail = 0, dwErr = ERROR_SUCCESS;

  dwErr = ReadPipeLine(&(pgparam->hStatus), szLine, MAX_LINE);
  if ((dwErr != ERROR_SUCCESS) && (dwErr != ERROR_HANDLE_EOF)) {
    goto finish_func;
  }
  if (dwErr == ERROR_HANDLE_EOF) {
    dwErr = ERROR_SUCCESS;
  }
  dwErr = InterpretAndSendGpgMsg(hwndmsg, szLine, pgparam->hCommand, pgparam->pLine2);
  if (!STRNCMPL("[GNUPG:] NEED_PASSPHRASE ", szLine)) {
    pgparam->pLine2 = pgparam->pPassphrase;
  } else if (!STRNCMPL("[GNUPG:] NEED_PASSPHRASE_SYM ", szLine)) {
    pgparam->pLine2 = pgparam->pPassphraseSym;
  } else if (!STRNCMPL("[GNUPG:] BAD_PASSPHRASE", szLine)) {
    dwErr = ERROR_INVALID_DATA;
  } else if (!STRNCMPL("[GNUPG:] MISSING_PASSPHRASE", szLine)) {
    dwErr = ERROR_INVALID_DATA;
  } else if (!STRNCMPL("[GNUPG:] GET_HIDDEN ", szLine)) {
    pgparam->pLine2 = NULL;
  }
finish_func:
  if (psjis) FREE(psjis);
  return dwErr;
}

/*------------------------------------------------------------*/
/**
 * \fn DWORD finishupGpgEncrypt(LPVOID buff)
 *
 * gpg.exeǏn
 * ĎpɊJĂstatus-fdcommand-fdp̃pCv
 *
 */
DWORD
finishupGpgEncrypt(LPVOID buff) {
  PCHAINEDPROCESS_NODE pp = (PCHAINEDPROCESS_NODE)buff;
  PGPGENCRYPT_PARAM pgparam = (PGPGENCRYPT_PARAM)pp->buff;

  if (pgparam->hCommand != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hCommand));
  if (pgparam->hStatus != INVALID_HANDLE_VALUE) CloseHandleClean(&(pgparam->hStatus));
  return ERROR_SUCCESS;
}

/*------------------------------------------------------------*/
